Unit qMouse;

{$R-,S-,F+,O+,D-,L-,Y-}

INTERFACE

Uses
	Dos,Crt,Graph;

Type
	Mouse_Mask = record
		Screen,Cursor : array[1..16] of word;
	end;

Const
	Arrow : Mouse_Mask = (
			Screen : ($ffff,$ffff,$ffff,$ffff,
						 $ffff,$ffff,$ffff,$ffff,
						 $ffff,$ffff,$ffff,$ffff,
						 $ffff,$ffff,$ffff,$ffff);
			Cursor : ($c000,$a000,$9000,$8800,
						 $8400,$8200,$8100,$8080,
						 $8040,$83e0,$9200,$a900,
						 $c900,$0480,$0480,$0380)
						);

	Hand : Mouse_Mask = (            { 0, 2}
		Screen : (
			$ffff, $ffff, $1fff, $0fff,
			$07ff, $8249, $8000, $c000,
			$e000, $e000, $e000, $c000,
			$8001, $0007, $001f, $87ff
		);
		Cursor : (
			$0000, $0000, $e000, $9000,
			$8800, $45b6, $4249, $2121,
			$1081, $1001, $1001, $2001,
			$4006, $8038, $87e0, $7800
		)
	);

	Pen : Mouse_Mask = (                { 0, 0}
		Screen : (
			$e3ff, $c1ff, $80ff, $007f,
			$003f, $001f, $800f, $c007,
			$f001, $f001, $f800, $fc01,
			$fe03, $ff07, $ff8f, $ffdf
		);
		Cursor : (
			$fc00, $f200, $e900, $c480,
			$a240, $9120, $4890, $2448,
			$1224, $0912, $0489, $0246,
			$0124, $0098, $0050, $0020
		)
	);

   Box : Mouse_Mask = (
   	Screen : (
		   $ffff, $ffff, $ffff, $f007,
		   $e003, $e7f3, $e7f3, $e7f3,
		   $e7f3, $e7f3, $e7f3, $e7f3,
		   $e003, $f007, $ffff, $ffff
      );
		Cursor : (
		   $0000, $0000, $0000, $0000,
		   $07f0, $0808, $0808, $0808,
		   $0808, $0808, $0808, $0808,
		   $07f0, $0000, $0000, $0000
	   )
   );


	{᪨ }
   No_B     = $0000;
	Left_B   = $0001;
	Right_B  = $0002;
	Center_B = $0004;

	Ms_CAll  = $33;

	{ ᪨   ࠬ Call_Mask }
	Pos_Changed    = $0001;
	Left_Press     = $0002;
	Left_Release   = $0004;
	Right_Press    = $0008;
	Right_Release  = $0010;
	Center_Press   = $0020;
	Center_Release = $0040;

	nButton : integer = 0; { -    }

var
	VideoMode : byte absolute $0:$449;

function MsInit(var nButtons : integer ) : boolean;

procedure MsShow;
procedure MsHide;

procedure MsRead(var x,y,b_Mask : word);
procedure MsReadMotion(var hCount, vCount : word);
procedure MsSetPos(x,y : word);
procedure MsLightPenOn;
procedure MsLightPenOff;
function MsGetB(    b_Mask : word;
					 var count  : word;
					 var Last_x,Last_y : word) : word;
function MsGetBRelease(    b_Mask : word;
							  var count  : word;
							  var Last_x,Last_y : word) : word;
procedure MsSetHMinMax( Min,Max : word);
procedure MsSetVMinMax( Min,Max : word);
procedure MsSetGraphPointer (hotx,hoty : word;
									var image);
procedure MsSetTextPointer(  select : word;
										  char_attr_StLine : word;
										  char_Attr_EndLine : word);
procedure MsSetMPP(hMPP,vMPP : word);
procedure MsCondOff(Top, Left, Bottom, Right : word);
procedure MsSet2Speed(MPS : word);
procedure MsSetRoutine(call_Mask : word; sub : pointer);
procedure MsSwapRoutine( call_mask     : word;
									sub           : pointer;
									var Last_Call_Mask : word;
									var Last_sub      : pointer);

function MsGetStateBfSz : word;
procedure MsGetState (Var Ms_State);
procedure MsSetState (var Ms_State);
procedure MsSetVPage(Ms_V_Page : word);
function MsGetVPage : word;

implementation
uses
	qGraph;

Var
	Reg : Registers;
	Curx,Cury           		: word; { ⥪騥 न  }
	Oldx1,Oldy1,Oldx2,Oldy2 : word;

function MsInit(var nButtons : integer) : boolean;
begin
	if InGraph and (grDriver = HercMono) then VideoMode := 6;
	Reg.Ax := 0;
	Intr(Ms_Call,Reg);
	if Reg.Ax = 0 then
	begin
	 nButtons := 0;
	 MsInit  := false;
	end
	else
	begin
		nButtons := Reg.Bx;
		MsInit := true;
	end;
end;

procedure MsShow;
begin
  Reg.Ax := 1;
  Intr(Ms_call,Reg);
end;

procedure MsHide;
begin
	Reg.Ax := 2;
	Intr(Ms_Call,Reg);
end;

procedure MsRead(var x,y,b_Mask : word);
begin
	Reg.Ax := 3;
	Intr(Ms_Call,reg);
	x := Reg.CX;
	y := Reg.DX;
	b_Mask := Reg.BX;
end;


procedure MsSetPos(x,y : word);
begin
	Reg.AX := 4;
	Reg.CX := x;
	Reg.DX := y;
	Intr(Ms_Call,Reg);
end;


function MsGetB(    b_Mask : word;
					  var count  : word;
					  var Last_x,Last_y : word) : word;
begin
	Reg.AX := 5;
	Reg.BX := b_Mask;
	Intr(Ms_Call,Reg);
	count := Reg.BX;
	Last_x := Reg.CX;
	Last_y := Reg.DX;
	MsGetB := Reg.Ax;
end;

function MsGetBRelease(    b_Mask : word;
								  var count  : word;
								  var Last_x,Last_y : word) : word;
begin
	Reg.AX := 6;
	Reg.BX := b_mask;
	Intr(Ms_Call,Reg);
	count := Reg.BX;
	Last_x := Reg.CX;
	Last_y := Reg.DX;
	MsGetBRelease := Reg.Ax;
end;

procedure MsSetHMinMax( Min,Max : word);
begin
	Reg.AX := 7;
	Reg.CX := Min;
	Reg.DX := Max;
	Intr(Ms_Call,Reg);
end;

procedure MsSetVMinMax( Min,Max : word);
begin
	Reg.AX := 8;
	Reg.CX := Min;
	Reg.DX := Max;
	Intr(Ms_Call,Reg);
end;

procedure MsSetGraphPointer (hotx,hoty : word;
									var image);
begin
	Reg.AX := 9;
	Reg.BX := hotx;
	Reg.CX := hoty;
	Reg.DX := Ofs(image);
	Reg.ES := Seg(image);
	Intr(Ms_Call,Reg);
end;

procedure MsSetTextPointer(  select : word;
									  char_attr_StLine : word;
									  char_Attr_EndLine : word);
begin
	Reg.AX := 10;
	Reg.BX := select;
	Reg.CX := char_attr_StLine;
	Reg.DX := char_attr_EndLine;
	Intr(Ms_Call,Reg);
end;

procedure MsReadMotion(var hCount, vCount : word);
begin
	Reg.AX := 1;;
	Intr(Ms_Call,Reg);
	hCount := Reg.CX;
	vCount := Reg.DX;
end;

procedure MsSetRoutine(call_Mask : word; sub : pointer);
begin
	Reg.AX := 12;
	Reg.CX := Call_mask;
	Reg.ES := Seg(sub^);
	Reg.DX := Ofs(sub^);
	Intr(Ms_Call,Reg);
end;

procedure MsLightPenOn;
begin
	Reg.AX := 13;
	Intr(Ms_Call,Reg);
end;

procedure MsLightPenOff;
begin
	Reg.AX := 14;
	Intr(Ms_Call,Reg);
end;

procedure MsSetMPP(hMPP,vMPP : word);
begin
	if (hMPP >= 1) and (hMPP <= 32767) and (vMPP >= 1) and (vMPP <= 32767)
	then
		begin
			Reg.AX := 15;
			Reg.CX := hMPP;
			Reg.dX := vMPP;
			Intr(Ms_Call,Reg);
		end;
end;

procedure MsCondOff(Top, Left, Bottom, Right : word);
begin
	Reg.AX := 16;
	Reg.CX := Left;
	Reg.DX := Top;
	Reg.SI := Right;
	Reg.DI := Bottom;
	Intr(Ms_Call,Reg);
end;

procedure MsSet2Speed(MPS : word);
begin
	Reg.AX := 19;
	Reg.DX := MPS;
	Intr(Ms_Call,Reg);
end;

procedure MsSwapRoutine( call_mask     : word;
									sub           : pointer;
									var Last_Call_Mask : word;
									var Last_sub      : pointer);
begin
	Reg.AX := 20;
	Reg.CX := call_mask;
	Reg.DX := Ofs(sub^);
	Reg.ES := Seg(sub^);
	Intr(Ms_Call,Reg);
	Last_Call_mask := Reg.CX;
	last_sub := Ptr(Reg.ES,Reg.DX);
end;

function MsGetStateBfSz : word;
begin
	Reg.AX := 21;
	Intr(Ms_Call,Reg);
	MsGetStateBfSz := Reg.BX;
end;

procedure MsGetState (Var Ms_State);
begin
	Reg.AX := 22;
	Reg.BX := Ofs(Ms_State);
	Reg.ES := Seg(MS_State);
	Intr(Ms_Call,Reg);
end;

procedure MsSetState (var ms_State);
begin
	Reg.Ax := 23;
	Reg.DX := Ofs(Ms_State);
	Reg.ES := Seg(Ms_State);
	Intr(Ms_Call,Reg);
end;

function MsGetVPage : word;
begin
	Reg.AX := 30;
	Intr(Ms_Call,Reg);
	MsGetVPage := Reg.BX;
end;

procedure MsSetVPage(Ms_V_Page : word);
begin
	Reg.AX := 29;
	Reg.BX := Ms_V_Page;
	Intr(Ms_Call,Reg);
end;

end.











